<template>
	<div class="decrypter lightestpink-color">
		<div class="header flex space">	
			<div class="node-info">
				<div class="flex space v-top">
					<div class="type hustle medium lightest-pink-color">{{getLocale('structure_main_decrypter')}}</div>
					<div class="level medium-font">LV{{node.data.level}}</div>
				</div>
				
				<v-button 
					v-if="node.data.level < structureMaxLevel('decrypter')"
					:text="getLocale('upgrade')"
					:secondary_text="structureUpgradeCost('decrypter', node.data.level)"
					:icons="[ 'bytes_black.svg' ]"
					:disabled="checkStructureByteCost('decrypter', node.data.level)"
					color="lightestpink"
					@clicked="upgradeNode(node.id)"
				/>
			</div>
			
			<div class="level-bar">
				<div class="bar">
					<div class="base lightestpink-bkg" :style="{width : (4*node.data.level)+'%'}"></div>
				</div>
				
				<div class="bonus" :class="{'active' : node.data.level >= 5}" :style="{left : '20%'}" v-tooltip="'decrypter_perk_1'">
					<div class="icon lightestpink-border"></div>
					<div class="level bold">LV5</div>
					<div class="effect">{{getLocale('decrypter_perk_1_label')}}</div>
				</div>
				
				<div class="bonus" :class="{'active' : node.data.level >= 15}" :style="{left : '60%'}" v-tooltip="'decrypter_perk_2'">
					<div class="icon lightestpink-border"></div>
					<div class="level bold">LV15</div>
					<div class="effect">{{getLocale('decrypter_perk_2_label')}}</div>
				</div>
			</div>
			
			<tutorial-icon color="#feb3ff" @clicked="setTutorial('decrypter', -1, true)"/>
		</div>
		
		<div class="align-center">
			<div class="description">{{getLocale('structure_main_decrypter_effect')}}</div>
			
			<div class="content special flex space v-top" :class="[current_process != null ? 'active green-border green-color' : 'lightestpink-border ']">
				<div class="top-section uppercase">
					<div v-if="assigned_vairus" class="flex space v-center">
						<div class="production-cycle flex h-center v-center">
							<div class="prev noselect" v-on:click="prevCycle" v-if="node.data.level >= 5">
								<svg xmlns="http://www.w3.org/2000/svg" width="28.284" height="28.284" viewBox="0 0 28.284 28.284">
									<g id="info" transform="translate(14.142) rotate(45)" :fill="current_process != null ? '#00FFB4' : '#feb3ff'">
										<path id="close-circle-o" d="M12.6,6.26l1.405,1.408L7.4,14.24,6,12.832ZM10,.25a9.625,9.625,0,0,1,7.072,2.934A9.643,9.643,0,0,1,20,10.25a9.643,9.643,0,0,1-2.927,7.066A9.625,9.625,0,0,1,10,20.25a9.625,9.625,0,0,1-7.072-2.934A9.645,9.645,0,0,1,0,10.25,9.64,9.64,0,0,1,2.927,3.184,9.626,9.626,0,0,1,10,.25Zm0,18.028a7.684,7.684,0,0,0,5.644-2.348,7.747,7.747,0,0,0,2.342-5.681,7.747,7.747,0,0,0-2.342-5.681A7.684,7.684,0,0,0,10,2.222,7.684,7.684,0,0,0,4.356,4.569,7.747,7.747,0,0,0,2.014,10.25a7.747,7.747,0,0,0,2.342,5.681A7.684,7.684,0,0,0,10,18.278Z" transform="translate(0 -0.25)"/>
									</g>
								</svg>
							</div>
							<div class="cycle">{{production_cicles[current_cycle].label}}</div>
							<div class="next noselect" v-on:click="nextCycle" v-if="node.data.level >= 5">
								<svg xmlns="http://www.w3.org/2000/svg" width="28.284" height="28.284" viewBox="0 0 28.284 28.284">
									<g id="info" transform="translate(14.142) rotate(45)" :fill="current_process != null ? '#00FFB4' : '#feb3ff'">
										<path id="close-circle-o" d="M12.6,6.26l1.405,1.408L11.382,10.25l2.623,2.582L12.6,14.24,9.977,11.658,7.4,14.24,6,12.832,8.572,10.25,6,7.668,7.4,6.26,9.977,8.842ZM10,.25a9.625,9.625,0,0,1,7.072,2.934A9.643,9.643,0,0,1,20,10.25a9.643,9.643,0,0,1-2.927,7.066A9.625,9.625,0,0,1,10,20.25a9.625,9.625,0,0,1-7.072-2.934A9.645,9.645,0,0,1,0,10.25,9.64,9.64,0,0,1,2.927,3.184,9.626,9.626,0,0,1,10,.25Zm0,18.028a7.684,7.684,0,0,0,5.644-2.348,7.747,7.747,0,0,0,2.342-5.681,7.747,7.747,0,0,0-2.342-5.681A7.684,7.684,0,0,0,10,2.222,7.684,7.684,0,0,0,4.356,4.569,7.747,7.747,0,0,0,2.014,10.25a7.747,7.747,0,0,0,2.342,5.681A7.684,7.684,0,0,0,10,18.278Z" transform="translate(0 -0.25)"/>
									</g>
								</svg>
							</div>
						</div>
						
						<div class="arrow">→</div>
						
						<div class="flex">
							<div class="flex v-center" v-for="shard in shards_production">
								<div>{{shard.value}}</div>
								<div class="icon"  :style="{ 'background-image' : getShardImage(shard.type) }"></div>
							</div>
						</div>
					</div>
				</div>
				
				<div class="action uppercase black-color bold" :class="{assigned : assigned_vairus}">
					<div v-if="assigned_vairus">
						<div v-if="current_process == null" class="start green-bkg" v-on:click="startDecrypter">
							{{ getLocale('start') }}
						</div>
						
						<div v-else class="stop lightestpink-bkg"  v-on:click="stopDecrypter">
							{{ getLocale('cancel')}}
						</div>
					</div>
				</div>
				
				<div class="assignment">
					<div class="wrapper row-padding col-padding">
						<vairus-card 
							v-if="node.data.assignment"
							@clicked="requestList"
							:vairus="findVairus(node.data.assignment)"
							:highlighted="false"
							:show_footer="false"
							:hide_exhaustion="true"
							color="pink"
						/>
						
						<empty-card v-else @clicked="requestList" />
					</div>
					
					<div class="rain" v-if="current_process">
						<div class="drop" :class="n" v-for="n in 19" :style="{left : (5*n)+'%'}"></div>
					</div>
				</div>
				
				<div class="bottom-section flex v-center h-center"></div>
				
				<v-info 
					class="efficiency" 
					:color="current_process == null ? '#FEB3FF' : '#00FFB4'" 
					:text="Math.floor(structureEffect('decrypter', node.data.level)*100)+'%'" 
					v-tooltip="'main_efficiency_tooltip'"
				/>
				
				<v-info 
					v-if="current_process != null"
					class="time" 
					color="#00FFB4" 
					:text="parseTime(current_process.end*1000 - current_time)" 
				/>
			</div>
		</div>
	</div>
</template>


<script>
	import { commonMixin } from '../../mixins/common.js';
	import { structuresMixin } from '../../mixins/structures.js';
	import { storeGettersMixin } from '../../mixins/store_getters.js';
	import VButton from '../VButton.vue';
	import VInfo from '../VInfo.vue';
	import TutorialIcon from '../TutorialIcon.vue';
	import VairusCard from '../VairusCard.vue';
	import EmptyCard from '../EmptyCard.vue';
	import structuresManager from '../../classes/structuresManagerClass.js';
	
	var browser = browser || chrome;
	
	export default {
		props: ['node'],
		data: function () {
			return{
				cycle : 0
			}
		},
		computed: {
			current_cycle(){
				if(this.current_process != null){
					let data = JSON.parse(this.current_process.other_data);
					return this.production_cicles.findIndex(function(c){ return c.value == data.cycle; });
				}
				return this.cycle;
			},
			production_cicles(){
				var cycles = [
					{ value : 1, label : '01H'},
					{ value : 2, label : '02H'},
					{ value : 4, label : '04H'}
				];
				
				if(this.node.data.level >= 15){
					cycles.push({value : 8, label : '08H'});
					cycles.push({value : 24, label : '24H'});
				}
				
				return cycles;
			},
			assigned_vairus(){
				let vairus = this.vairus_list.find(function(v){
					return v.unique_id == this.node.data.assignment;
				}.bind(this));
				
				return (typeof vairus !== 'undefined') ? vairus : null;
			},
			current_process(){
				if(this.node.data.assignment == null) return null;
				
				let process = this.processes.find(function(p){
					return p.vairus_id == this.node.data.assignment;
				}.bind(this));
				
				return (typeof process !== 'undefined') ? process : null;
			},
			shards_production(){
				let effect = structuresManager.getEffect('compiler', this.node.data.level);
				let value = 0;
				let types = [];
				
				for(var stat in this.assigned_vairus.current_stats){
					value += this.assigned_vairus.current_stats[stat].total;
				}
				
				let production = Math.max(1, Math.floor(Math.round(value*effect)/3)/24);
				
				
				for(var type in this.assigned_vairus.vairus_type.affinities){
					types.push({
						type : type,
						value : Math.floor(production * this.production_cicles[this.current_cycle].value)
					});
				}
				
				return types;
			},
		},
		methods: {
			parseTime(timestamp){
				if(timestamp < 0) timestamp = 0;
			
				let d = Math.floor((timestamp / (1000 * 60 * 60 * 24)));
				timestamp -=  d*(1000 * 60 * 60 * 24);
				let h = Math.floor((timestamp / (1000 * 60 * 60)));
				let m = Math.floor((timestamp / (1000 * 60)) % 60);
				let s = Math.floor((timestamp / 1000) % 60);
				
				if(h > 0){
					return  h.toString().padStart(2, '0')+'H '+m.toString().padStart(2, '0')+'M '+s.toString().padStart(2, '0')+'S';
				}
				
				return m.toString().padStart(2, '0')+'M '+s.toString().padStart(2, '0')+'S';
			},
			startDecrypter(){
				if(this.start_process_lock) return;
				this.$store.commit('setActionLock', 'start_process_lock');
				
				browser.runtime.sendMessage({
					type : 'start_node_process',
					data : { 
						node_id : this.node.id.replace('n', ''),
						type : 'decrypter',
						cycle : this.production_cicles[this.cycle].value
					}
				});
			},
			stopDecrypter(){
				if(this.current_process != null){
					browser.runtime.sendMessage({
						type : 'stop_process',
						data : this.current_process.id
					});
				}
			},
			prevCycle(){
				this.cycle = Math.max(0, this.cycle-1);
			},
			nextCycle(){
				this.cycle = Math.min(this.production_cicles.length, this.cycle+1);
			},
			requestList(){
				if(this.current_process != null){
					if(confirm(this.getLocale('stop_process_warning'))){
						this.$emit('requestlist');
					}
				}else{
					this.$emit('requestlist');
				}
			}
		},
		mixins: [commonMixin, structuresMixin, storeGettersMixin],
		components: {
			VButton, VInfo, VairusCard, EmptyCard, TutorialIcon
		}
	}
</script>


<style lang="scss" scoped>
	@import "../../styles/variables";
	
	.decrypter{
		.description{
			text-align: left;
			position: absolute;
			width: 200px;
		}
		
		.assignment{
			.vairus-card,
			.empty-card{
				margin: 0;
			}
		}
		.top-section{
			height: 75px !important;
			padding: 25px !important;
		}
		
		.production-cycle{
			padding: 5px;
			background-color: black;
			border-radius: 20px;
	
			.cycle{
				width: 30px;
				text-align: center;
				margin: 0 5px;
			}
			svg{
				display: block;
				cursor: pointer;
			}
		}
	
		.shard-type{
			margin-left: 10px;
		}
		.icon{
			width: 20px;
			height: 20px;
			background-size: contain;
			background-repeat: no-repeat;
			background-position: center;
		}
		
		.rain{
			.drop{
				position: absolute;
				width: 1px;
				height: 30px;
				background-color: $green;
				animation: rain 1s linear infinite;
				
				@for $i from 1 through 19 {
					&:nth-of-type(#{$i}) {
						animation-delay: random() + s;
						animation-duration: (0.5 + random()) + s;
					}
				}
			}
		}
		
		.content.active .production-cycle svg{
			opacity: 0.5;
			pointer-events: none;
		}
		@media screen and (max-width: 800px) {
			.description{
				width: 100%;
				text-align: right;
				right: 25px;
			}	
			.content{
				margin-top: 50px !important;
			}
		}	
		
		@media screen and (max-width: 700px) {
			.level-bar{
				display: none;
			}
			.header {
				margin-bottom: -20px !important;
			}
		}
		@media screen and (max-width: 400px) {
			.vairus-card{
				width: 175px;
				height: 250px;
			}
		}
	}
	
	@keyframes rain{
		0%{
			top: calc(0% - 100px);
		}
		100%{
			top: calc(100% + 100px);
		}
	}
</style>








